package org.mirkorusso.K2KC45;

import org.knime.core.node.defaultnodesettings.DefaultNodeSettingsPane;
import org.knime.core.node.defaultnodesettings.DialogComponentBoolean;
import org.knime.core.node.defaultnodesettings.DialogComponentNumber;
import org.knime.core.node.defaultnodesettings.SettingsModelBoolean;
import org.knime.core.node.defaultnodesettings.SettingsModelDouble;
import org.knime.core.node.defaultnodesettings.SettingsModelInteger;

/**
 * <code>NodeDialog</code> for the "Esempio" Node.
 * 
 *
 * This node dialog derives from {@link DefaultNodeSettingsPane} which allows
 * creation of a simple dialog with standard components. If you need a more 
 * complex dialog please derive directly from 
 * {@link org.knime.core.node.NodeDialogPane}.
 * 
 * @author Mirko Russo
 */
public class K2KC45NodeDialog extends DefaultNodeSettingsPane {

    /**
     * New pane for configuring Esempio node dialog.
     * This is just a suggestion to demonstrate possible default dialog
     * components.
     */
    protected K2KC45NodeDialog() {
        super();

        addDialogComponent(new DialogComponentBoolean(new SettingsModelBoolean
        		(K2KC45NodeModel.BOOL, true), "Pruned"));
        addDialogComponent(new DialogComponentNumber(new SettingsModelDouble
        		(K2KC45NodeModel.DBL, .25),"Confidence:", 0.01));
        addDialogComponent(new DialogComponentNumber(new SettingsModelInteger
        		(K2KC45NodeModel.INT, 2), "Instances per leafe:", 1));
    }
}

