package org.mirkorusso.K2KC45;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Hashtable;

import org.knime.core.data.DataCell;
import org.knime.core.data.DataColumnSpec;
import org.knime.core.data.DataColumnSpecCreator;
import org.knime.core.data.DataRow;
import org.knime.core.data.DataTableSpec;
import org.knime.core.data.container.CloseableRowIterator;
import org.knime.core.data.def.DefaultRow;
import org.knime.core.data.def.StringCell;
import org.knime.core.node.BufferedDataContainer;
import org.knime.core.node.BufferedDataTable;
import org.knime.core.node.ExecutionContext;

public class KEEL2KNIME {
	
	BufferedDataTable predictionsExtractor(String ResultPath, 
			BufferedDataTable t, ExecutionContext exec) throws IOException {
		FileReader f = new FileReader(ResultPath);
	    BufferedReader b = new BufferedReader(f);
	    Hashtable<Integer, String> predictions = new Hashtable<>();
	    String s = b.readLine();
	    
	    for(int i = 0; s != null; i++) {
	    	predictions.put(i, s);
	    	s = b.readLine();
	    }
	    
	    int j = 0;
	    Boolean gotIt = false;
	    
	    while(!gotIt) {
	    	if(predictions.get(j).contentEquals("@data")) 
	    		gotIt = true;
	    	j++;
	    }
	    
	    int l = j;
	    
	    for(;j < predictions.size(); j++) {
	    	String ClPlusPr = predictions.get(j);
	    	ClPlusPr = (String) ClPlusPr.subSequence(ClPlusPr.indexOf(" ") + 1, ClPlusPr.length());
			predictions.put(j,ClPlusPr);
	    }
	    
	    DataTableSpec inputTableSpec = t.getDataTableSpec();
    	DataColumnSpec[] outputColumnSpecs = new DataColumnSpec[inputTableSpec.getNumColumns() + 1];
    	
    	for (int i = 0; i < inputTableSpec.getNumColumns(); i++)
    	   		outputColumnSpecs[i] = inputTableSpec.getColumnSpec(i);
    	
    	outputColumnSpecs[inputTableSpec.getNumColumns()] = 
    			new DataColumnSpecCreator("Prediction", StringCell.TYPE).createSpec();
    	
    	DataTableSpec outputTableSpec = new DataTableSpec(outputColumnSpecs);
    	BufferedDataContainer container = exec.createDataContainer(outputTableSpec);
    	CloseableRowIterator it = t.iterator();
    	DataRow r = null;
    	
    	while(it.hasNext()) {
    		r = it.next();
    		DataCell[] cells = new DataCell[outputColumnSpecs.length];
    		
    		for (int i = 0; i < inputTableSpec.getNumColumns(); i++)
    			cells[i] = r.getCell(i);
    		
    		cells[inputTableSpec.getNumColumns()] = new StringCell(predictions.get(l++));
    		DataRow row = new DefaultRow(r.getKey(), cells);
    		container.addRowToTable(row);
    	}
    	
    	container.close();
    	b.close();
		return container.getTable();
	}
}
